package de.gurkengewuerz.ripmewrapper;

import de.gurkengewuerz.ripmewrapper.handler.APIHandler;
import de.gurkengewuerz.ripmewrapper.handler.StaticHandler;
import org.eclipse.jetty.server.ConnectionFactory;
import org.eclipse.jetty.server.Connector;
import org.eclipse.jetty.server.Handler;
import org.eclipse.jetty.server.HttpConnectionFactory;
import org.eclipse.jetty.server.Server;
import org.eclipse.jetty.server.handler.ContextHandler;
import org.eclipse.jetty.server.handler.ContextHandlerCollection;
import org.eclipse.jetty.server.session.SessionHandler;

import java.io.File;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.Statement;
import java.util.Timer;

/**
 * Created by gurkengewuerz.de on 09.10.2018.
 */
public class Webserver {

    public static boolean CRAWLER_IS_RUNNING = false;

    public static void main(String... args) throws Exception {
        Connection connection = DriverManager.getConnection("jdbc:sqlite:reddit_meta.db");
        Statement statement = connection.createStatement();
        statement.setQueryTimeout(30);  // set timeout to 30 sec.

        statement.executeUpdate("CREATE TABLE IF NOT EXISTS metalist (id string, subreddit string, created integer, title string, file string)");
        statement.executeUpdate("CREATE TABLE IF NOT EXISTS filelist (iid INTEGER PRIMARY KEY AUTOINCREMENT, id string, path string, md5 string)");
        connection.close();


        Server server = new Server(3030);

        for (Connector y : server.getConnectors()) {
            for (ConnectionFactory x : y.getConnectionFactories()) {
                if (x instanceof HttpConnectionFactory) {
                    ((HttpConnectionFactory) x).getHttpConfiguration().setSendServerVersion(false);
                }
            }
        }

        ContextHandler context_root = new ContextHandler("/");
        context_root.setContextPath("/");
        context_root.setHandler(new StaticHandler());

        ContextHandler context_api = new ContextHandler("/api");
        context_api.setContextPath("/api");
        SessionHandler s = new SessionHandler();
        s.setHandler(new APIHandler());
        context_api.setHandler(s);

        ContextHandlerCollection contexts = new ContextHandlerCollection();
        contexts.setHandlers(new Handler[]{context_root, context_api});
        server.setHandler(contexts);

        Timer timer = new Timer();
        timer.schedule(new ImageCrawler(), 0, 5 * 60 * 1000);

        server.start();
        server.dumpStdErr();
        server.join();
    }

    public static File getStaticdir() {
        return new File(System.getProperty("user.dir") + File.separator + "html" + File.separator);
    }
}
